const Shell   = imports.gi.Shell;
const GLib    = imports.gi.GLib;
const Meta    = imports.gi.Meta;
const Gio     = imports.gi.Gio;
const Utils   = imports.misc.extensionUtils.getCurrentExtension().imports.utils; 
const Tweener = imports.ui.tweener;
const Gettext = imports.gettext.domain('toggle_nautilus@kirby33');
const _ = Gettext.gettext;
const Config = imports.misc.config;
const key_bindings = {'toggle-nautilus': function() {_toggleNautilus();}};
const mySettings = Utils.getSettings();

function _toggleNautilus() {
	let win = _getWindowActor();
	if (win === 'start') {
		_startNautilus();
		return;
	}
        if (!win) {
            return;
        }
        // minimize/unmaximize
        if (win.minimized) {
		win.unminimize();
		win.activate(global.get_current_time());
        } else {
		win.minimize();
        }
}

function _startNautilus(){
	imports.misc.util.trySpawnCommandLine('/usr/bin/nautilus');
}

function _getWindowActor(){
	let window = 'start';
	let nautilusString = _("nautilus.desktop");

	let wins = global.screen.get_active_workspace().list_windows();
	let tracker = Shell.WindowTracker.get_default();
        for ( let i = 0; i < wins.length; ++i ) {
		let metaWindow = wins[i];
		if ( metaWindow && tracker.is_window_interesting(metaWindow) ) {
			let app = tracker.get_window_app(metaWindow);
			if ( app ) {
				let appId = app.get_id();
				if ((appId == nautilusString) ){
					window=metaWindow;
					i=wins.length;
				}
			}
		}
	}

	return window;
}

function init(meta) {
	extensionpath=meta.path;
	Utils.initTranslations("toggle_nautilus@kirby33");
}

function enable() {
	for(key in key_bindings) {
		global.display.add_keybinding(key,
			mySettings,
			Meta.KeyBindingFlags.NONE,
			key_bindings[key]
		);
	}
	Wnck.Screen.get_default().force_update();
}

function disable() {
	for(key in key_bindings) {
		global.display.remove_keybinding(key);
	}
}
